#! /bin/bash
#
#Please add env variable in this script

#set tools
processorType=`uname -m`
if [ "$processorType" == "x86_64" ];then
        echo "processor type x86_64"
        export PATH="/mtkoss/jdk/jdk1.6.0_23/bin:/usr/local/jdk1.6.0_02/bin:/mtkoss/scons/2.0.1-ubuntu-10.04/x86_64/bin:/usr/local/scons-1.1.0/bin:$PATH"
elif [ "$processorType" == "i686" ];then
        echo "processor type i686"
        export PATH="/usr/local/jdk1.6.0_02/bin:/usr/local/scons-1.1.0/bin:$PATH"
else
        echo "unknown processor type"
        exit 1
fi

java_version=`java -version 2>&1 | head -n 1 | grep '[ "]1\.6[\. "$$]'`
if [ "$java_version" == "" ];then
        echo "You are attempting to build with the incorrect version"
        echo "The correct java version is: 1.6.x"
        exit 1
fi
echo "scons path = `which scons`"
echo "java path = `which java`"
echo "scons version = `scons -v`"
`java -version`
echo "python version"
`python -V`


cpu_count=`cat /proc/cpuinfo |grep processor|wc -l`
#[ -z ${JOBS+-} ] && export JOBS="$cpu_count"


export JOBS=$(expr $cpu_count \* 2)

[ -z ${ARCH+-} ] && export ARCH=arm

if [ -e $BUILD_ROOT/build/configuration ]; then
		BUILD_DIR='build'
else
		BUILD_DIR='build_linux_ko'
fi

if [ "`grep mt8530 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export CROSS_COMPILE=armv6z-mediatek451_001_soft-linux-gnueabi-
	export KERNELRELEASE=2.6.27
elif [ "`grep mt8550 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export CROSS_COMPILE=armv6z-mediatek451_001_soft-linux-gnueabi-
	export KERNELRELEASE=2.6.27
elif [ "`grep mt8555 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export CROSS_COMPILE=armv6z-mediatek451_001_vfp-linux-gnueabi-
	export KERNELRELEASE=2.6.27
elif [ "`grep mt8551 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export CROSS_COMPILE=armv6z-mediatek451_001_vfp-linux-gnueabi-
	export KERNELRELEASE=2.6.35
elif [ "`grep mt8560 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export CROSS_COMPILE=armv6z-mediatek451_001_vfp-linux-gnueabi-
	export KERNELRELEASE=2.6.35
elif [ "`grep mt8561 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export CROSS_COMPILE=armv6z-mediatek451_001_soft-linux-gnueabi-
	export KERNELRELEASE=2.6.35
elif [ "`grep mt8552 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export CROSS_COMPILE=armv6z-mediatek451_001_soft-linux-gnueabi-
	export KERNELRELEASE=2.6.35
elif [ "`grep mt8580 $BUILD_ROOT/$BUILD_DIR/configuration`" != "" ]; then
	export KERNELRELEASE=2.6.35
	export CROSS_COMPILE=armv7a-mediatek451_001_vfp-linux-gnueabi-
else
	echo "Configuration = `cat $BUILD_ROOT/$BUILD_DIR/configuration`"
	echo "Please set IC configuration!"
        exit 1
fi
echo "KERNELRELEASE = $KERNELRELEASE"


# Compiler Option
which "$CROSS_COMPILE"gcc
if [ "$?" == "1" ]; then
	echo "Please set compiler path !"
	echo "COMPILER_PATH = $COMPILER_PATH"
	echo "PATH = $PATH"
	exit 1
else
	echo "COMPILER_PATH = $COMPILER_PATH"
fi


COMPILER=`which "$CROSS_COMPILE"gcc`
export COMPILER_PATH=`dirname $COMPILER`
ln -sfn $COMPILER_PATH CC_Folder 

#check tools
processorType=`uname -m`
if [ "$processorType" == "x86_64" ];then
        echo "processor type x86_64"
        export PATH="/mtkoss/lzop/1.03-rhel-4.6/x86_64/bin:$PATH"
elif [ "$processorType" == "i686" ];then
        echo "processor type i686"
        export PATH="/mtkoss/lzop/1.03-rhel-4.6/i686:$PATH"
else
        echo "unknown processor type"
        exit 1
fi

